/*
versio    1.0
yritys    Tietomato Oy
tekij    Tapio Lehtimki
			
asiakas   MikroBitti-lehti 

CommonFunctions.

Tarpeellisia yleiskyttisi funktioita.


Historia
14.08.2002  T~L Luonti

 */

import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;

public class CommonFunctions
{ 
	/* 
	********************************************************************************
	Constructor 
	********************************************************************************
	*/
	public CommonFunctions()
	{
	}
	
	/* 
	********************************************************************************
	Numeric string
	********************************************************************************
	*/		
	public static boolean isNumeric(String s)
	{
		int i;
		int n;
		char c;
		boolean bReturn = true;
		
		s = s.trim();
		n = s.length();
		if (n == 0) 
		{return false;}
		else
		{
			i = 0;
			while (i < s.length())
			{
				c = s.charAt(i);
				if (c == '0' || c == '1' || c == '2' || c == '3' || c == '4' || 
					c == '5' ||	c == '6' || c == '7' || c == '8' || c == '9') 
				{
					i++;
					continue;
				}
				else
				{
					bReturn = false;
					break;
				}
			}
			return bReturn;
		}
	}
	
	/* 
	********************************************************************************
	Integer to String
	********************************************************************************
	*/		
	public static String intToStr(int n)
	{
		String s;
		s = " " + n;
		return s.trim();
	}
	
	/* 
	********************************************************************************
	String to integer
	********************************************************************************
	*/		
	public static int strToInt(String s)
	{		
		int i;
		int n;
		int nLength;
		double fPow;
		int nPow;		
		char c;
		int nReturn = 0;
		
		s = s.trim();
		nLength = s.length();
		if (isNumeric(s))
		{
			i = 0;
			while (i < nLength)
			{
				n = 0;
				c = s.charAt(i);
				if (c == '0')
				{n = 0;}
				else if (c == '1')
				{n = 1;}				
				else if (c == '2')
				{n = 2;}				
				else if (c == '3')
				{n = 3;}				
				else if (c == '4')
				{n = 4;}				
				else if (c == '5')
				{n = 5;}				
				else if (c == '6')
				{n = 6;}				
				else if (c == '7')
				{n = 7;}				
				else if (c == '8')
				{n = 8;}												
				else if (c == '9')
				{n = 9;}
				
				fPow = n * Math.pow(10, nLength - 1 - i);
				nPow = (int)fPow ;
				nReturn = nReturn + nPow; 
				i++;
			}
		}
		else
		{nReturn = 0;}
		
		return nReturn;
	}
	
	/* 
	********************************************************************************
	now
	********************************************************************************
	*/	
	public static String now(String sFormat, int nHourPlus)
	{
		GregorianCalendar gcNow = new GregorianCalendar();
		return formatDate(sFormat, gcNow, nHourPlus);		
	}	

	
	/*
	********************************************************************************
	getHour, Win95 and Win98 operating systems have different hour handling.
	In Win98 first hour is zero, in Win95 it is one. Parameter nOS tells to
	this function should it add one to hour or not.
	********************************************************************************
	*/	
	public static int getHour(GregorianCalendar gc, int nHourPlus)	
	{
		int n;
		
		//n = gc.getMinimum(GregorianCalendar.HOUR_OF_DAY); // not working
		if (nHourPlus != 0)
			nHourPlus = 1;
		
		n = gc.get(GregorianCalendar.HOUR_OF_DAY) + nHourPlus;
		return n;
	}
	
	/* 
	********************************************************************************
	formatDate
	********************************************************************************
	*/	
	private static String formatDate(String sFormat, GregorianCalendar gc, int nHourPlus)		
	{		
		int n;
		String sYYYY;
		String sYY;	
		String sDD;
		String sMM;
		String sD;
		String sM;				
		
		String sHH;
		String sNN;		
		String sSS;
		String sH;
		String sN;		
		String sS;		
		
		n = gc.get(GregorianCalendar.YEAR);
		sYYYY = String.valueOf(n);
		sYY = sYYYY.substring(2, 4);		
		
		n = gc.get(GregorianCalendar.MONTH) + 1;	
		sM  = String.valueOf(n);
		sMM = intToLZstr(n, 2);		
		
		n = gc.get(GregorianCalendar.DAY_OF_MONTH);
		sD  = String.valueOf(n);	
		sDD = intToLZstr(n, 2);
		
		//n = gc.getMinimum(GregorianCalendar.HOUR_OF_DAY);
		//if (n == 0) 
		//{n = gc.get(GregorianCalendar.HOUR_OF_DAY) + 1;}
		//
		//{n = gc.get(GregorianCalendar.HOUR_OF_DAY);}
		
		n = getHour(gc, nHourPlus); 
		sH  = String.valueOf(n);
		sHH = intToLZstr(n, 2);
		
		n = gc.get(GregorianCalendar.MINUTE);
		sN  = String.valueOf(n);
		sNN = intToLZstr(n, 2);
		
		n = gc.get(GregorianCalendar.SECOND);
		sS  = String.valueOf(n);
		sSS = intToLZstr(n, 2);
		
		if (!sFormat.equals("")) 
		{
			sFormat = formatDateElement(sFormat, "YYYY", sYYYY);
			sFormat = formatDateElement(sFormat, "YY",   sYY);		
			sFormat = formatDateElement(sFormat, "MM",   sMM);
			sFormat = formatDateElement(sFormat, "M",    sM);					
			sFormat = formatDateElement(sFormat, "DD",   sDD);
			sFormat = formatDateElement(sFormat, "D",    sD);	
			sFormat = formatDateElement(sFormat, "HH",   sHH);
			sFormat = formatDateElement(sFormat, "H",    sH);						
			sFormat = formatDateElement(sFormat, "NN",   sNN);
			sFormat = formatDateElement(sFormat, "N",    sN);	
			sFormat = formatDateElement(sFormat, "SS",   sSS);
			sFormat = formatDateElement(sFormat, "S",    sS);				
		}			
		
		return sFormat;		
	}
	
	/* 
	********************************************************************************
	format
	********************************************************************************
	*/	
	private static String formatDateElement(String sFormat, String sElement, String sValue)	
	{
		int i = 0;
		int n = 0;
		String sReturn;
		String sTempFormat;		
		
		sTempFormat = "~" + sFormat;
		i = sTempFormat.indexOf(sElement);
		if (i > 0) 
		{
			n = i + sElement.length();
			sReturn = sTempFormat.substring(1, i) + sValue + 
				sTempFormat.substring(n, sTempFormat.length());
		}
		else
		{sReturn = sFormat;}
		
		return sReturn;		
	}	
	
	/* 
	********************************************************************************
	Fill leading zero
	********************************************************************************
	*/	
	public static String intToLZstr(int nValue, int nLength)	
	{
		String s;
		String sValue;
		String sReturn;
		int nFillLength;
		int i;
		
		sValue = String.valueOf(nValue);
		nFillLength = nLength - sValue.length();
		
		if (nFillLength == 0) 
		{sReturn = sValue;}
		else if (nFillLength < 0)
		{sReturn = sValue.substring(nFillLength * -1, nLength);}
		else
		{
			sReturn = sValue;
			i = 0;
			while (i < nFillLength)
			{
				sReturn = "0" + sReturn;
				i++;
			}
		}
		
		return sReturn;
	}
	
	/* 
	********************************************************************************
	makeFilename
	********************************************************************************
	*/			
	public static String makeFilename(String sPath, String sFile)	
	{
		String s = sPath + sFile;
		File file = new File(s);			
		if (file.exists())
		{
			return s;
		}
		
		s = sFile;
		file = new File(sFile);	
		if (file.exists())
		{
			return s;
		}
		return sFile;
	}
	
	/* 
	********************************************************************************
	replace substring
	********************************************************************************
	*/		
	public static String strReplace(String sSource, String sOld, String sNew)
	{	
		int i = 0;
		String s;
		try
		{
			i = sSource.indexOf(sOld);
			s = sSource.substring(0, i);
			s = s + sNew + sSource.substring(i + sOld.length(), sSource.length());
			return s;
		}
		catch (Exception e)
		{
			return sSource;
		}
	}
	
	/* 
	********************************************************************************
	Null value testing
	********************************************************************************
	*/		
	public static boolean isNull(String sValue)
	{
		try
		{
			sValue.compareTo(" ");
			return false;
		}
		catch (NullPointerException e)
		{
			return true;
		}
	}
	
}	