/*
versio    1.0
yritys    Tietomato Oy
tekij    Tapio Lehtimki
			
asiakas   MikroBitti-lehti 

sovellus  Filosofit kiinalaisessa ravintolassa

Philosopehrs-luokka periytyy Javan luokasta "JFrame" ja toteuttaa liittymn
PhListener, joka kuuntelee filosofiolioiden tunnetiloja.


Historia
02.10.2002  T~L Luonti	
*/

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;

public class Philosophers extends JFrame implements ActionListener, SbarListener
{
	
	//private	SpringLayout Layout = new SpringLayout();
	//private Container Cnr;
	
	private Container ContentPane = getContentPane();
	
	private ButtonPanel PnlButtons;
	private RestaurantPanel PnlRestaurant;
	private SettingPanel PnlSetting;	
	private JPanel PnlMessage;
	
	/* 
	********************************************************************************
	Konstruktori
	********************************************************************************
	*/	
	public Philosophers()
	{
		setSize(500, 500);
		setTitle("Filosofit kiinalaisessa ravintolassa");	
		
		Image ImgLogo = Toolkit.getDefaultToolkit().getImage("mato16.gif");
		setIconImage(ImgLogo);
		WinExit oWinExit = new WinExit();	
		addWindowListener(oWinExit);
		
		PnlButtons = new ButtonPanel(this);
		ContentPane.add(PnlButtons, "West");
		
		PnlRestaurant = new RestaurantPanel();
		ContentPane.add(PnlRestaurant, "Center");
		
		PnlSetting = new SettingPanel(this);
		ContentPane.add(PnlSetting, "South");
	}
	
	/* 
	********************************************************************************
	Pikkuna 
	********************************************************************************
	*/		
	public static void main(String[] args)
	{ 
		Philosophers frame = new Philosophers();		
		frame.show();
	}
	
	/* 
	********************************************************************************
	ActionListener-liittymmetodi
	********************************************************************************
	*/		
	public void actionPerformed(ActionEvent evt)
	{
		if (evt.getActionCommand().equals(Constants.S_CMD_START))
		{PnlRestaurant.startThreads();}
		if (evt.getActionCommand().equals(Constants.S_CMD_KILL))
		{
			PnlRestaurant.killThreads();
			PnlRestaurant.cleanTable();		
		}		
	}
	
	/* 
	********************************************************************************
	SbarListener-liittymmetodi
	Kyttj voi veivata rullaavilla lautoilla filosofien ruokahalua ja nlnsieto-
	kyky huonommaksi tai paremmaksi.
	********************************************************************************
	*/			
	public void barScrolled(int nId, int nValue)
	{
		if (nId == Constants.N_CMD_APPETITE)
		{PnlRestaurant.setAppetite(nValue);}
		else if (nId == Constants.N_CMD_STARVING)
		{PnlRestaurant.setStarving(nValue);}			
		else if (nId == Constants.N_CMD_LUNCHHOUR)
		{PnlRestaurant.setLunchHour(nValue);}					
	}
	
} //END

