/*
versio    1.0
yritys    Tietomato Oy
tekij    Tapio Lehtimki
			
asiakas   MikroBitti-lehti 

Luokasta "JPanel" periytetty paneeli, jolle piirretn pyt, filosofit 
ja sympuikot

Historia
04.10.2002  T~L Luonti	
*/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.plaf.*;

public class RestaurantPanel extends JPanel implements PhListener, ActionListener, PopListener
{ 
	private	SpringLayout Layout = new SpringLayout();
	private Vector moPhilosopherBtns;
	private Vector moPhilosopherIcons;
	private Vector moPhilosopherOneStickIcons;
	
	private JLabel  LblTable;
	
	private Philosopher Descartes;
	private Philosopher Kant;
	private Philosopher Nietzche;
	private Philosopher Ockham;
	private Philosopher Saarinen;
	
	private JButton BtnDescartes;
	private JButton BtnKant;
	private JButton BtnNietzche;
	private JButton BtnOckham;
	private JButton BtnSaarinen;
	
	private ImageIcon moStarved;	
	private ImageIcon moDeadLock;	
	private ImageIcon moEat;
	
	private Vector moSticks;
	private JLabel LblStick0;
	private JLabel LblStick1;
	private JLabel LblStick2;
	private JLabel LblStick3;
	private JLabel LblStick4;
  
  private PopupPri MnuPri;
  private int[] maPri = {4, 4, 4, 4, 4};
	
	private int mnWaitingThreads;	
	
	private int mnAppetite;
	private int mnStarving;
	private int mnLunchHour;
	private boolean mbOpenCommunication;
	
  private final int N_DESCARTES = 0;
  private final int N_OCKHAM    = 1;
  private final int N_NIETZCHE  = 2;
  private final int N_SAARINEN  = 3;
  private final int N_KANT      = 4;
	private final String[] NAMES = {"Descartes",  "Ockham",  "Nietzche", "Saarinen", "Kant"};	
	private final int R = 150;
	private final double[] SIN_STICK = {0.58,  0.95,  0.00, -0.95, -0.58};	
	private final double[] COS_STICK = {0.80, -0.27, -1.00, -0.27,  0.80};	
	private final double[] SIN_PHILO = {0.00,  0.95,  0.58, -0.58, -0.95};	
	private final double[] COS_PHILO = {1.00,  0.27, -0.80, -0.80,  0.27};
	private final int PHILO_STICK_SIZE = 70;
	private final int TABLE_SIZE = 150;
	private final int TOP_MARGIN = 10;		
	
	/* 
  ********************************************************************************
	Konstruktori 
  ********************************************************************************
  */
	public RestaurantPanel()
	{
		setLayout(Layout);
		setTable();
		moPhilosopherBtns  = new Vector();
		moPhilosopherIcons = new Vector();	
		moPhilosopherOneStickIcons = new Vector();		
		moSticks = new Vector();		
		moStarved  = new ImageIcon("starved.jpg");	
		moDeadLock = new ImageIcon("deadlock.jpg");		
		moEat = new ImageIcon("eat.jpg");		

  /*  Filosofipainikkeet */		
		BtnDescartes = createPhilosopherBtn(N_DESCARTES);		
		BtnOckham    = createPhilosopherBtn(N_OCKHAM);					
		BtnNietzche  = createPhilosopherBtn(N_NIETZCHE);		
		BtnSaarinen  = createPhilosopherBtn(N_SAARINEN);
		BtnKant      = createPhilosopherBtn(N_KANT);
		
		LblStick0 = createChopstick(0, "Stick0");		
		LblStick1 = createChopstick(1, "Stick1");					
		LblStick2 = createChopstick(2, "Stick2");			
		LblStick3 = createChopstick(3, "Stick3");			
		LblStick4 = createChopstick(4, "Stick4");	
		
		mnAppetite   = Constants.N_DEF_APPETITE;
		mnStarving   = Constants.N_DEF_CATCHSTICK;
		mnLunchHour  = Constants.N_DEF_LUNCHHOUR;
    mbOpenCommunication = false;

    /*  Filosofisikeet */		
    Descartes = createPhilosopherThread(N_DESCARTES);		
		Ockham    = createPhilosopherThread(N_OCKHAM);					
		Nietzche  = createPhilosopherThread(N_NIETZCHE);		
		Saarinen  = createPhilosopherThread(N_SAARINEN);
		Kant      = createPhilosopherThread(N_KANT);	
        
    /*  Listn ponnahdusvalikko prioriteettien st varten */
    MnuPri = new PopupPri(this);
	}
	
	
	/* 
  ********************************************************************************
	Katetaan pyt 
  ********************************************************************************	
  */			
	private void setTable()
	{
		int xy = R + (PHILO_STICK_SIZE / 2) - (TABLE_SIZE / 2);
		ImageIcon oImage = new ImageIcon("Table.jpg");			
		LblTable = new JLabel(oImage);						
		SpringLayout.Constraints oConstr = Layout.getConstraints(LblTable);
		Spring xSpring = Spring.constant(xy);
		Spring ySpring = Spring.constant(xy + TOP_MARGIN);	
		Spring wSpring = Spring.constant(TABLE_SIZE);			
		Spring hSpring = Spring.constant(TABLE_SIZE);
		oConstr.setX(xSpring);
		oConstr.setY(ySpring);		
		oConstr.setWidth(wSpring);
		oConstr.setHeight(hSpring);	
		LblTable.setToolTipText("Ruokapyt");				
		add(LblTable);			
		LblTable.setVisible(true);
		
	}
	
	/* 
  ********************************************************************************
	Pidot voivat alkaa - kynnistetn sikeet  
  ********************************************************************************	
  */			
	public void startThreads()
	{
		/*  Kyseess ei vlttmtt ole ensimminen startti, niinp yritetn tappaa
		vanha porukka alta pois. */
		
		killThreads();
		cleanTable();
		
		mnWaitingThreads = 0;
    
		Descartes = createPhilosopherThread(N_DESCARTES);		
		Ockham    = createPhilosopherThread(N_OCKHAM);					
		Nietzche  = createPhilosopherThread(N_NIETZCHE);		
		Saarinen  = createPhilosopherThread(N_SAARINEN);
		Kant      = createPhilosopherThread(N_KANT);	
		
		mbOpenCommunication = true;
		
		setPriorities();	
		Descartes.start();
		Ockham.start();
		Nietzche.start();
		Saarinen.start();
		Kant.start();
	}

	/* 
  ********************************************************************************
	Luodaan filosofille demonisie. Demoni poikkeaa demonittomasta sikeest siin,
	ett demoni ptt pivns viimeistn silloin, kun sen luoja lopettaa suorituksen.
  ********************************************************************************	
  */			
	private Philosopher createPhilosopherThread(int i)
	{
		Philosopher oPhilosopher; 
		int iLeftStick = i - 1;
		if (iLeftStick < 0) 
		{iLeftStick = 4;}
		int iRightStick = i;
		oPhilosopher = new Philosopher(i, iLeftStick, iRightStick, this, mnAppetite, mnStarving, mnLunchHour);
		oPhilosopher.setName(NAMES[i]);
		oPhilosopher.setDaemon(true);
		return oPhilosopher;
	}  

	/* 
  ********************************************************************************
	Sikeiden prioriteettien asetus  
  ********************************************************************************	
  */			
	public void setPriorities()
  {
		try {Descartes.setPriority(maPri[N_DESCARTES]);} catch(Exception e) {};	
		try {Ockham.setPriority(maPri[N_OCKHAM]);}       catch(Exception e) {};	
		try {Nietzche.setPriority(maPri[N_NIETZCHE]);}   catch(Exception e) {};			
		try {Saarinen.setPriority(maPri[N_SAARINEN]);}   catch(Exception e) {};		
		try {Kant.setPriority(maPri[N_KANT]);}           catch(Exception e) {};	
  }
	
	/* 
  ********************************************************************************
	Siivotaan pyt aiempien kierrosten jljilt
  ********************************************************************************	
  */	
	public void cleanTable()
	{
		BtnDescartes.setIcon((ImageIcon)moPhilosopherIcons.get(0));				
		BtnOckham.setIcon((ImageIcon)moPhilosopherIcons.get(1));						
		BtnNietzche.setIcon((ImageIcon)moPhilosopherIcons.get(2));			
		BtnSaarinen.setIcon((ImageIcon)moPhilosopherIcons.get(3));	
		BtnKant.setIcon((ImageIcon)moPhilosopherIcons.get(4));
		
		LblStick0.setVisible(true);		
		LblStick1.setVisible(true);						
		LblStick2.setVisible(true);				
		LblStick3.setVisible(true);				
		LblStick4.setVisible(true);
	}
	
	/* 
  ********************************************************************************
	Keskeytetn symingit pysyttmll sikeet 
  ********************************************************************************	
  */			
	public void killThreads()
	{
		mbOpenCommunication = false;		
		killThread(Descartes);
		killThread(Kant);
		killThread(Nietzche);
		killThread(Ockham);
		killThread(Saarinen);
	}
	
	/* 
  ********************************************************************************
	Yksittisen sikeen likvidointi 
  ********************************************************************************	
  */			
	public void killThread(Thread oThread)
	{
		if ((oThread != null) && (oThread.isAlive()))
		{
			try
			{
				oThread.interrupt();
				/* join aiheuttaa tss vliss herksti lukkiutuman, kun jdn odottelemaan
				   edell keskeytetyskomennon saanutta siett. Sie on jo saattanut kuolla
				   kupsahtaa, eik komento koskaan palaa odottavaan join:iin. 
        */ 
				//oThread.join(); 
				oThread = null;
			}
			catch (Exception e)
			{};
		}		
	}
	
	/* 
  ********************************************************************************
	Listn filosofille kuvallinen painike ikkunaan  
  ********************************************************************************	
  */			
	private JButton createPhilosopherBtn(int i)
	{
    String sName = NAMES[i];
    String sNro = "" + i;
		ImageIcon oIcon = new ImageIcon(sName + ".jpg");
		JButton oBtn = new JButton(oIcon);
		placePhiloStick(i, (Component)oBtn, SIN_PHILO, COS_PHILO); 	
    
    /*  Painikkeiden kuuntelijaksi asetetaan tm olio itse */
    oBtn.addActionListener(this); 
    /*  Painikkeiden tunnisteeksi kunkin filosofin nro */
    oBtn.setActionCommand(sNro);
    /*  Painikkeen vihjetekstiksi tulee filosofin nimi */
    oBtn.setToolTipText(sName);		
		moPhilosopherIcons.add(oIcon);			
		moPhilosopherBtns.add(oBtn);	
		
		ImageIcon oIcon1 = new ImageIcon(sName + "1.jpg");
		moPhilosopherOneStickIcons.add(oIcon1);			
		return oBtn;
	}
	
	/* 
  ********************************************************************************
	Listn sympuikko  
  ********************************************************************************	
  */			
	private JLabel createChopstick(int i, String sName)
	{
		int nNro = i + 1;
		String sNro = "" + nNro;
		ImageIcon oIcon = new ImageIcon(sName + ".jpg");
		JLabel oLbl = new JLabel(oIcon);
		placePhiloStick(i, (Component)oLbl, SIN_STICK, COS_STICK); 
		oLbl.setToolTipText("Sympuikko nro " + sNro);		
		moSticks.add(oLbl);			
		return oLbl;			
	}
	
	/* 
  ********************************************************************************
	Sijoitetaan filosofi tai sympuikko pydn reen 
  ********************************************************************************	
  */			
	private void placePhiloStick(int i, Component oComponent, double[] sin, double[] cos)
	{
		int x = calculateX(i, sin);
		int y = calculateY(i, cos);	
		
		SpringLayout.Constraints oConstr = Layout.getConstraints(oComponent);
		Spring xSpring = Spring.constant(x);
		Spring ySpring = Spring.constant(y);	
		Spring wSpring = Spring.constant(PHILO_STICK_SIZE);			
		Spring hSpring = Spring.constant(PHILO_STICK_SIZE);
		oConstr.setX(xSpring);
		oConstr.setY(ySpring);		
		oConstr.setWidth(wSpring);
		oConstr.setHeight(hSpring);	
		
		add(oComponent);
		oComponent.setVisible(true);
	}
  
	/* 
  ********************************************************************************
	Lasketaan x-koordinaatti sinitaulukon avulla.
  ********************************************************************************	
  */			
	private int calculateX(int i, double[] sin)
	{
		return (int)Math.round(R * sin[i]) + R;
  }
	/* 
  ********************************************************************************
	Lasketaan y-koordinaatti kosinitaulukon avulla. 
  ********************************************************************************	
  */			
	private int calculateY(int i, double[] cos)
  {
		return (int)Math.round(R * cos[i]) + R + TOP_MARGIN;	
  }	
  
	/* 
  ********************************************************************************
	Asetetaan filosofien ruokahalu
  ********************************************************************************	
  */			
	public void setAppetite(int value)
	{
		try
		{
			mnAppetite = value;		
			suspendPhilosophers();
			Descartes.setAppetite(value);
			Ockham.setAppetite(value);		
			Nietzche.setAppetite(value);
			Saarinen.setAppetite(value);
			Kant.setAppetite(value);
			notifyPhilosophers();
		}
		catch(Exception e)
		{}
	}
	
	/* 
  ********************************************************************************
	Asetetaan filosofien nlnsietokyky
  ********************************************************************************	
  */			
	public void setStarving(int value)
	{
		try
		{
			mnStarving = value;			
			suspendPhilosophers();
			Descartes.setStarving(value);
			Ockham.setStarving(value);		
			Nietzche.setStarving(value);
			Saarinen.setStarving(value);
			Kant.setStarving(value);
			notifyPhilosophers();
		}
		catch(Exception e)
		{}		
	}
	
	/* 
  ********************************************************************************
	Asetetaan ruokailun kesto
  ********************************************************************************	
  */			
	public void setLunchHour(int value)
	{
		try
		{		
			mnLunchHour = value;		
			suspendPhilosophers();
			Descartes.setLunchHour(value);
			Ockham.setLunchHour(value);		
			Nietzche.setLunchHour(value);
			Saarinen.setLunchHour(value);
			Kant.setLunchHour(value);
			notifyPhilosophers();
		}
		catch(Exception e)
		{}		
	}
	
	/* 
  ********************************************************************************
	Filosofit jhylle
  ********************************************************************************	
  */			
	public void suspendPhilosophers()
	{
		try	{waitThread(Descartes);} catch(Exception e) {}		
		try	{waitThread(Ockham);}    catch(Exception e) {}				
		try	{waitThread(Nietzche);}  catch(Exception e) {}			
		try	{waitThread(Saarinen);}  catch(Exception e) {}
		try	{waitThread(Kant);}      catch(Exception e) {}
	}
	
	/* 
  ********************************************************************************
	Filosofit takaisin peliin
  ********************************************************************************	
  */			
	public void notifyPhilosophers()
	{
    setPriorities();
		try {notifyThread(Descartes);} catch(Exception e) {}		
		try {notifyThread(Ockham);	 } catch(Exception e) {}			
		try {notifyThread(Nietzche); } catch(Exception e) {}			
		try {notifyThread(Saarinen); } catch(Exception e) {}	
		try {notifyThread(Kant);     } catch(Exception e) {}		
	}
	
	/* 
  ********************************************************************************
	Pysytetn filosofit hetkeksi wait-komennolla
  ********************************************************************************	
  */			
	public void waitThread(Thread oThread)
	{
		try
		{
			if (oThread.isAlive())
			{oThread.wait();}
		}
		catch (Exception e)
		{};
	}
	
	/* 
  ********************************************************************************
	Hertetn odottavat filosofit notify-komennolla
  ********************************************************************************	
  */			
	public void notifyThread(Thread oThread)
	{
		try
		{
			if (oThread.isAlive())
			{oThread.notify();}
		}
		catch (Exception e)
		{};
	}
	
	/* 
  ********************************************************************************
	PhListener-liittymmetodi: ZarahustraSpeaks
	Filososfien mielenliikkeet ja tilamuutokset huomioidaan	tll.
  ********************************************************************************	
  */			
	public void ZarahustraSpeaks(int nId, int nState)
	{
		ImageIcon oIcon;
		ImageIcon oIcon1;
		JButton oBtn;
		int i;
		int nWaitingThreads = mnWaitingThreads;
		
		/*  Kommunikaatiokanava sikeisiin pin suljetaan sikeiden joutuessa tappolistalle, eivtk 
		elmns ehtooseen ajetut sikeet eivt en pse sotkemaan asioiden kulkua. */
		if (mbOpenCommunication)
		{
			oIcon  = (ImageIcon)moPhilosopherIcons.get(nId);	
			oIcon1 = (ImageIcon)moPhilosopherOneStickIcons.get(nId);			
			oBtn   = (JButton)moPhilosopherBtns.get(nId);
			
			if (nState == Philosopher.STATE_THINK)  
			{
				oBtn.setIcon(oIcon);
				mnWaitingThreads--;		
			}
			else if (nState == Philosopher.STATE_GOT1STICK)
			{
				oBtn.setIcon(oIcon1);
			}
			else if (nState == Philosopher.STATE_WAIT2STICK)
			{
				oBtn.setIcon(oIcon1);
				mnWaitingThreads++;
			}				
			else if (nState == Philosopher.STATE_STARVED)
			{
				oBtn.setIcon(moStarved);
			}
			else if (nState == Philosopher.STATE_EAT)
			{
				oBtn.setIcon(moEat);
				moPhilosopherBtns.set(nId, oBtn);
			}
			
			/*  Tarkistetaan ovatko sikeet jneet deadlock-tilanteeseen. Jos ovat,
			    tapetaan ne ja nytetn kallon kuvaa tikun kera. Tarkistetaan mys,
				  etteivt menehtyvien sikeiden kuolinuudot liipaise teurastusta
				  turhaan liikkeelle yh uudelleen. 
      */
			if ((mnWaitingThreads == 5) && (mnWaitingThreads != nWaitingThreads)) 
			{
				LblStick0.setVisible(false);		
				LblStick1.setVisible(false);						
				LblStick2.setVisible(false);				
				LblStick3.setVisible(false);				
				LblStick4.setVisible(false);			
				killThreads();	
				i = 0;			
				while (i < 5)
				{
					oBtn  = (JButton)moPhilosopherBtns.get(i);
					oBtn.setIcon(moDeadLock);
					moPhilosopherBtns.set(i, oBtn);	
					i = i + 1;
				}
			}
		}
	}
	
	/* 
  ********************************************************************************
	PhListener-liittymmetodi: getStick	
	Filosofi hapuilee sympuikkoa. 
  ********************************************************************************	
  */	
	public boolean getStick(int iStick)
	{
		JLabel oLbl;
		oLbl = (JLabel)moSticks.get(iStick);
		if (oLbl.isVisible())
		{
			oLbl.setVisible(false);
			return true;
		}
		else
		{			
			return false;
		}
	}
	
	/* 
  ********************************************************************************
	PhListener-liittymmetodi: leaveStick	
	Kyllinen filosofi luopuu sympuikostaan. 
  ********************************************************************************	
  */	
	public void leaveStick(int iStick)	
	{
		JLabel oLbl;
		oLbl = (JLabel)moSticks.get(iStick);
		oLbl.setVisible(true);	
	}
	
	/* 
  ********************************************************************************
	ActionListener-liittymmetodi.
  Hertt ponnahdusvalikon prioriteettien stmiseksi.
  ********************************************************************************
  */		
	public void actionPerformed(ActionEvent evt)
	{
    String sNro;
    int i;
    int x;
    int y;
    int nPri;
    Philosopher oPhilosopher;
    JButton oBtn;
    
    sNro = evt.getActionCommand();
    i = CommonFunctions.strToInt(sNro);
    nPri = maPri[i];
    oBtn = (JButton)moPhilosopherBtns.get(i);
    x = calculateX(i, SIN_PHILO);
    y = calculateY(i, COS_PHILO);
    MnuPri.setName(NAMES[i]);
    MnuPri.setPhilosopherInd(i);
    MnuPri.setPri(nPri);
    MnuPri.show(this, x, y);
	}	
  
	/* 
  ********************************************************************************
	PopListener-liittymmetodi
  Pivitetn filosofikohtainen prioriteetti. 
  ********************************************************************************
  */			
	public void setPri(int i, int nPri)
  {
    suspendPhilosophers();
    maPri[i] = nPri;
    notifyPhilosophers();
  }
	
} //END	