/*
versio    1.0
yritys    Tietomato Oy
tekij    Tapio Lehtimki
			
asiakas   MikroBitti-lehti 

Javan luokasta "JPanel" periytetty asetusten stpaneeli.

Historia
05.10.2002  T~L Luonti	
*/

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class SettingPanel extends JPanel implements AdjustmentListener 
{ 
	private JScrollBar SbAppetite;
	private JScrollBar SbStarving;
	private JScrollBar SbLunchHour;	
	private SbarListener Listener;
	
	/* 
	********************************************************************************
	Konstruktori 
	
	Rullaimen parametrit:
	JScrollBar(int orientation, int value, int extent, int min, int max) 
	********************************************************************************
	*/
	public SettingPanel(SbarListener listener)
	{	
		Listener = listener;
		setLayout(new GridLayout(3, 3, 5, 5));		
		
		/*  Ensimminen rivi */
		JLabel lblFiller1 = new JLabel("");	
		add(lblFiller1);		
		lblFiller1.setVisible(true);
		
		JLabel lblAppetite = new JLabel("Ruokahalu");	
		add(lblAppetite);		
		lblAppetite.setVisible(true);
		
		SbAppetite = new JScrollBar(JScrollBar.HORIZONTAL, Constants.N_DEF_APPETITE, 10, 1, 200);
		SbAppetite.addAdjustmentListener(this);
		add(SbAppetite);
		SbAppetite.setVisible(true);		
		
		/*  Toinen rivi */			
		JLabel lblFiller2 = new JLabel("");	
		add(lblFiller2);		
		lblFiller2.setVisible(true);
		
		JLabel lblStarving = new JLabel("Nlnsieto");	
		add(lblStarving);		
		lblStarving.setVisible(true);
		
		/* Rollaattorille ei voi asettaa arvoksi maksimeita luontivaiheessa, siksi ylimrinen
		   setValue-lause (N_DEF_CATCHSTICK on sama kuin N_STARVING_MAX eli 100) */
		SbStarving = new JScrollBar(JScrollBar.HORIZONTAL, 50, 10, 1, Constants.N_STARVING_MAX);
		SbStarving.setValue(Constants.N_DEF_CATCHSTICK);
		SbStarving.addAdjustmentListener(this);	
		add(SbStarving);
		SbStarving.setVisible(true);	
		
		/*  Kolmas rivi */
		JLabel lblFiller3 = new JLabel("");	
		add(lblFiller3);		
		lblFiller3.setVisible(true);
		
		JLabel lblLunchHour = new JLabel("Ruokailun kesto");	
		add(lblLunchHour);		
		lblLunchHour.setVisible(true);
		
		SbLunchHour = new JScrollBar(JScrollBar.HORIZONTAL, Constants.N_DEF_LUNCHHOUR, 1, 1, 50);
		SbLunchHour.addAdjustmentListener(this);
		add(SbLunchHour);
		SbLunchHour.setVisible(true);						
	}
	
	/* 
	********************************************************************************
	AdjustmentListener-liittymmetodi: adjustmentValueChanged
	JScrollBar on niin mlli, ettei se osaa identifioida itsen, muuten kuin
	palauttamalla kysyttess adjustable-objektin. Hygieenisyyssyist napataan
	eventti kiinni tll ja lhetetn siistityt tiedot varsinaiselle kuuntelijalle
	eli Philosophers-pluokalle. 
	********************************************************************************
	*/			
	public void adjustmentValueChanged(AdjustmentEvent e)
	{
		int n;
		
		if (e.getAdjustable() == SbAppetite)
		{Listener.barScrolled(Constants.N_CMD_APPETITE, e.getValue());}
		else if (e.getAdjustable() == SbStarving)
		{Listener.barScrolled(Constants.N_CMD_STARVING, e.getValue());}		
		else if (e.getAdjustable() == SbLunchHour)
		{Listener.barScrolled(Constants.N_CMD_LUNCHHOUR, e.getValue());}				
	}
	
} //END	